//////////////////////////////////////////////////////////////////////
//
//                                                LinearRegression.mq4
//                                       Copyright  2008 Antonuk Oleg 
//
//////////////////////////////////////////////////////////////////////
#property copyright "Copyright  2008 Antonuk Oleg"
#property link      "antonukoleg@gmail.com"
#property indicator_chart_window

#property indicator_buffers 1
#property indicator_width1 1
#property indicator_color1 Gold

extern int barsToCount=50;

double buffer0[];

//////////////////////////////////////////////////////////////////////
int init()
{
   IndicatorShortName("linearRegression");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,buffer0);
   SetIndexEmptyValue(0,0.0);
   return(0);
}

//////////////////////////////////////////////////////////////////////
int deinit()
{  
   return(0);
}

extern string pr1 = "0 close, 1 open, 2 high, 3 low, 4 hl/2";
extern string pr2 = "5 hlc/3, 6 hlcc/4, 7 ma(4)";
extern int Price = 0;
double pr(int n)
{
    string currency = Symbol();
    bool inverse = false;

    double res = 0;
    switch(Price)
    {
    case 0: {res = (iClose(currency, 0, n));break;} 
    case 1: {res = (iOpen(currency, 0, n));break;}
    case 2: {res = (iHigh(currency, 0, n));break;}
    case 3: {res = (iLow(currency, 0, n));break;}
    case 4: {res = ((iHigh(currency, 0, n)+iLow(currency, 0, n))/2);break;}
    case 5: {res = ((iHigh(currency, 0, n)+iLow(currency, 0, n)+iClose(currency, 0, n))/3);break;}
    case 6: {res = ((iHigh(currency, 0, n)+iLow(currency, 0, n)+iClose(currency, 0, n)+iClose(currency, 0, n))/4);break;}
    case 7: {res = (iMA(currency,0,4,0,0,0,n));break;}
    default: res = 0;
    }
    
    if(inverse)
    {
        if(res != 0)
        {
            res = 1 / res;
        }
    }
    
    return (res);
}

/* 
 :
     ,    
    ,    , 
       

 :
    datetime dateWhere = 0;
    int nWhere = 0;
    C("LReg", Time[0], dateWhere, nWhere);
*/
void C(
                string name, datetime ,
                datetime & , int & 
                )
{
    if(ObjectType(name) != OBJ_VLINE)
    {
        ObjectDelete(name);
    }

    int found = ObjectFind(name);
    if(found == -1)
    {
        ObjectCreate(name, OBJ_VLINE, 0, , 0);
    }

     = ObjectGet(name, OBJPROP_TIME1);
    
    //    
    if( > Time[0]) {
         = Time[0];
    }
    
     = iBarShift(NULL, 0, , true);
}

int lastNWhere = -1;
int lastNBarsToCount = -1;

int start()
{
    datetime dateWhere = 0;
    int nWhere = 0;
    C("LReg", Time[0], dateWhere, nWhere);
    // ---------------------------------------------------------


    if((lastNWhere != nWhere) || (lastNBarsToCount != barsToCount))
    {
        for(int i = 0; i < Bars; i++)
        {
            buffer0[i] = EMPTY_VALUE;
        }
    }

   // calculate price values
   double b,k,c,
          sumy=0.0,
          sumx=0.0,
          sumxy=0.0,
          sumx2=0.0;

    int start = nWhere;
    int end = nWhere + barsToCount;
   
   for(i = start; i < end; i++)
   {
      sumy+=pr(i);
      sumxy+=pr(i)*i;
      sumx+=i;
      sumx2+=i*i;
   }
   
    Print("sumY is " + sumy);
    Print("sumXY is " + sumxy);
    Print("sumX is " + sumx);
    Print("sumX2 is " + sumx2);

   c=sumx2*barsToCount-sumx*sumx;
   
   Print("C is " + c);
   
   if(c==0.0)
   {
      Alert("LinearRegression error: can\'t resolve equation");
      return;
   }
      
   k=(sumxy*barsToCount-sumx*sumy)/c;
   b=(sumy-sumx*k)/barsToCount;
   
   // drawing Linear regression trendline in indicator buffer
   for(int x = start;x < end; x++)
   {
      buffer0[x]=k*x + b;
   }
   
   // clear last bar
   buffer0[x]=0.0;

   return(0);
}

